<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="100px"
      @submit.native.prevent
    >
      <el-row>
        <el-form-item label="电机名称" prop="motorName">
          <el-input
            v-model="queryParams.motorName"
            placeholder="请输入电机名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item style="margin-left: 20px">
          <el-button v-no-more-click
                     type="primary"
                     icon="el-icon-search"
                     size="mini"
                     @click="handleQuery"
          >搜索
          </el-button>
          <el-button v-no-more-click icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置
          </el-button>
        </el-form-item>
      </el-row>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button v-no-more-click
                   type="primary"
                   plain
                   icon="el-icon-plus"
                   size="mini"
                   @click="handleAdd"
                   v-hasPermi="['iscs:motor:add']"
        >新增
        </el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button v-no-more-click
                   type="danger"
                   plain
                   icon="el-icon-delete"
                   size="mini"
                   :disabled="multiple"
                   @click="handleDelete"
                   v-hasPermi="['iscs:motor:remove']"
        >批量删除
        </el-button>
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="repairList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="电机编码" align="center" prop="motorCode"/>
      <el-table-column label="电机名称" align="center" prop="motorName"/>
      <el-table-column label="隔离点绑定" align="center" prop="pointName" />
      <el-table-column label="电机类型" align="center" prop="motorType">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.motor_type" :value="scope.row.motorType"/>
        </template>
      </el-table-column>

      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button v-no-more-click
                     size="mini"
                     type="text"
                     icon="el-icon-edit"
                     @click="handleUpdate(scope.row)"
                     v-hasPermi="['iscs:motor:edit','iscs:motor:query']"
          >修改
          </el-button>
          <el-button v-no-more-click
                     size="mini"
                     type="text"
                     icon="el-icon-delete"
                     @click="handleDelete(scope.row)"
                     v-hasPermi="['iscs:motor:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />

    <!-- 添加或修改设备维修单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="450px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="电机编号" prop="motorCode">
          <el-input v-model="form.motorCode" placeholder="请输入电机编号" />
        </el-form-item>
        <el-form-item label="电机名称" prop="motorName">
          <el-input v-model="form.motorName" placeholder="请输入电机名称" />
        </el-form-item>
        <el-form-item label="隔离点绑定" prop="pointId">
          <el-select style="width:290px" v-model="form.pointId" placeholder="隔离点绑定" clearable>
            <el-option v-for="item in this.isolationPointOptions" :key="item.pointId" :label="item.pointName" :value="item.pointId">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="电机类型" align="center" prop="motorType" >
          <el-select style="width:290px" v-model="form.motorType" placeholder="选择电机类型" clearable>
            <el-option
              v-for="dict in dict.type.motor_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button v-no-more-click type="primary" @click="submitForm">确 定</el-button>
        <el-button v-no-more-click @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  getIsMotorPage,
  selectIsMotorById,
  addMotor,
  updateMotor,
  delMotor
} from "@/api/mes/motor/index";

import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

import { getIsIsolationPointPage } from '@/api/mes/spm/segregationPoint'
export default {
  name: "lock",
  dicts: ["hardware_status",'motor_type'],
  components: { Treeselect },
  data() {
    return {
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      codes: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // mars树选项
      marsOptions: [],
      // 总条数
      total: 0,
      // 设备维修单表格数据
      repairList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      createTime: "",
      queryParams: {
        current: 1,
        size: 10,
        motorName: null,
        motorId:null,
      },
      // 表单参数
      form: {
      },
      // 隔离点名称 下拉
      isolationPointOptions: null,
      hardWareList:[],//所属硬件
      // 表单校验
      rules: {
        motorName: [
          { required: true, message: "电机名称不能为空", trigger: "blur" },
        ],
        motorCode:[
          { required: true, message: "电机编码不能为空", trigger: "blur" },
        ],
        // pointId: [
        //   { required: true, message: "隔离点不能为空", trigger: "blur" },
        // ],
        mapId:[
          { required: true, message: "地图名称不能为空", trigger: "blur" },
        ]
      },
      // 日期选择
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      EditId: 0, //修改判断
      machinerytypeOptions: [], //锁具机构类型
      machineryOptions:[],//查询 设备工艺数据
    };
  },
  created() {
    this.getList();
    this.getOtherList()
  },
  methods: {

    /** 查询设备维修单列表 */
    getList() {
      this.loading = true;

      // 布局数据
      getIsMotorPage(this.queryParams).then((response) => {
        console.log(response,'布局')
        this.repairList = response.data.records;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    getOtherList(){
      const data={
        current:1,
        size:-1
      }
      // 获取地图类型 布局or地图
      getIsIsolationPointPage(data).then(response => {
        const dataValue = {
          pointName: '空',
          pointId: null,
        }
        this.isolationPointOptions = response.data.records
        this.isolationPointOptions = [...this.isolationPointOptions, dataValue]
      })

    },


    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        lotoName: null,
        workstationId: null,
        orderNum: null,
        map:null,
        lotoSerialNumber: null,
      };

      this.autoGenFlag = false;
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams.motorName = "";
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.motorId);
      this.codes = selection.map((item) => item.motorName);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.EditId = null;
      this.title = "新增电机信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.EditId = row.motorId || this.ids;
      selectIsMotorById(this.EditId).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改电机信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.EditId != null) {
            updateMotor(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            // console.log(this.form, "form");
            addMotor(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.EditId = null;
              this.getList();
            });
          }
        }
      });
    },

    /** 删除按钮操作 */
    handleDelete(row) {
      const repairIds = row.motorId || this.ids;
      const repairCodes = row.motorName || this.codes;
      this.$modal
        .confirm('是否确认删除所选数据项？')
        .then(function () {
          return delMotor(repairIds);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
  },
};
</script>
<style scoped>
.imgstatus {
  position: relative;
  top: 1px;
  left: 0px;
}

/deep/ .el-radio__inner {
  border-radius: 2px;
}

/deep/ .el-radio__input.is-checked .el-radio__inner::after {
  content: "";
  width: 8px;
  height: 3px;
  border: 1px solid white;
  border-top: transparent;
  border-right: transparent;
  text-align: center;
  display: block;
  position: absolute;
  top: 3px;
  left: 2px;
  transform: rotate(-45deg);
  border-radius: 0pc;
  background: none;
}
</style>
